<template>
    <validation-provider
        v-slot="validationContext"
        :name="name.toLowerCase() || label.toLowerCase()"
        :rules="rules"
        :vid="vid"
        ref="input"
    >
        <b-form-group
            class="full-width"
        >   
            <span
                class="label"
                :class="customLabelClass"
                v-if="label"
            >{{ label }}</span>

            <template v-if="type === 'input'">
                <b-form-input
                    :value="value"
                    :state="getValidationState(validationContext)"
                    :type="inputType"
                    :class="customInputClass"
                    :placeholder="placeholder"
                    :min="inputMin"
                    :max="inputMax"
                    class="my-input full-width"
                    :id="id"
                    @input="updateValue"
                    @focus="focus"
                    @blur="blur"
                />
            </template>

            <template v-if="type === 'textarea'">
                <b-form-textarea
                    :value="value"
                    :state="getValidationState(validationContext)"
                    :class="customInputClass"
                    :rows="rows"
                    :id="id"
                    class="my-input textarea full-width form-control"
                    @input="updateValue"
                    @focus="focus"
                    @blur="blur"
                />
            </template>

            <template v-if="type === 'select' && !multiple">
                <b-form-select
                    :value="value"
                    :state="getValidationState(validationContext)"
                    :class="customInputClass"
                    :id="id"
                    :options="options"
                    :multiple="multiple"
                    class="form-control custom-select full-width"
                    @change="updateValue"
                />
            </template>

            <template v-if="type === 'select' && multiple">
                <slot />
            </template>
            
            <b-form-invalid-feedback>{{ validationContext.errors[0] }}</b-form-invalid-feedback>
        </b-form-group>
    </validation-provider>
</template>

<script>
export default {
    model: {
        prop: 'value',
        event: 'input'
    },
    props: {
        customInputClass: String,
        customLabelClass: String,
        vid: String,
        multiple: Boolean,
        options: Array,
        value: [String, Object, Number, Array],   
        name: {
            type: String,
            default: '',
        },
        label: {
            type: String,
            default: '',
        },
        inputType: {
            type: String,
            default: 'text',
        },
        type: {
            type: String,
            default: 'input'
        },
        rules: {
            type: [Object, String],
            default: () => ({
                required: true,
            })
        }, 
        placeholder: {
            type: String,
            default: ''
        },
        inputMin: null,
        inputMax: null,
        rows: null,
        id: {
            type: String,
        }
    },
    created() {
        this.updateValue(this.value)
    },
    methods: {
        getValidationState({dirty, validated, valid = null}) {
            return dirty || validated ? valid : null;
        },
        async updateValue(value) {
           this.$emit('input', value)
           const input = this.$refs.input
           if(input) {
               const item = await  input.validate()  
               this.$emit('validate', item.valid)
           }
        },
        focus(e) {
            this.$emit('focus', e)
        },
        blur(e) {
            this.$emit('blur', e)
            console.log(this.value, 'value')
        }
    }
}
</script>

<style lang="scss" scoped>
.label {
    font-weight: 500;
    display: block;
    line-height: 100%;
    margin-bottom: 7px;
    &_light {
        font-weight: 400;
    }
}
.textarea {
    height: auto !important;
}
</style>
